﻿using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using System.IO;
using System.Security.Cryptography;
using System.Text;

public partial class Display : System.Web.UI.Page
{
   protected void Page_Load(object sender, EventArgs e)
    {
        Trace.Write("Enter Page_Load method");
        if (Request.Form.Count == 0)
        {
            return;
        }
        SymmetricAlgorithm rijndael = RijndaelManaged.Create();
       int blocksize = rijndael.BlockSize / 8;
        byte[] password = Encoding.UTF8.GetBytes(PreviousPage.PasswordData);
        byte[] key = new byte[blocksize];
        Array.Copy(password, key, (password.Length > blocksize) ? blocksize : password.Length);
        rijndael.Key = key;
        rijndael.IV = key;
        if (Request.Form["EncryptButton"] != null)
        {
            MemoryStream ms = new MemoryStream();
            using (CryptoStream cs = new CryptoStream(ms, rijndael.CreateEncryptor(), CryptoStreamMode.Write))
            {
                byte[] data = Encoding.UTF8.GetBytes(PreviousPage.TextData);
                cs.Write(data, 0, data.Length);
                cs.FlushFinalBlock();
                Text.Text = Cut(Convert.ToBase64String(ms.ToArray()));
            }
        }
        else
        {
            MemoryStream ms;
            try
            {
                ms = new MemoryStream(Convert.FromBase64String(PreviousPage.TextData));
            }
            catch (FormatException)
            {
                return;
            }
            try
            {
                using (CryptoStream cs = new CryptoStream(ms, rijndael.CreateDecryptor(), CryptoStreamMode.Read))
                {
                    byte[] result = new byte[ms.Length];
                    cs.Read(result, 0, (int)ms.Length);
                    Text.Text = Encoding.UTF8.GetString(result);
                }
            }
            catch (CryptographicException)
            {
            }
        }
    }

    string Cut(string s)
    {
        StringBuilder sb = new StringBuilder(s);
        for (int i = 32; i < sb.Length; i += 32)
        {
            sb.Insert(i, '\n');
            i++;
        }
        return sb.ToString();
    }
}
